
%define _unpackaged_files_terminate_build 0

%define DATE 20021208
%define PATCH_DATE 20030111
%define gcc_version 3.2.1
%define gcc_release 3

Summary: gcc cross-devel for ppc64
Name: cross-ppc64-gcc
Version: %{gcc_version}
Release: %{gcc_release}
URL: http://gcc.gnu.org/
Source0: gcc-%{version}-%{DATE}.tar.bz2
# gcc-20030111-ppc64.diff.gz
Patch0: gcc-%{PATCH_DATE}-ppc64.patch.gz
Copyright: GPL
Group: Development/Languages
BuildRoot: %{_tmppath}/%{name}-root
BuildRequires: cross-ppc64-binutils >= 2.13.90
Prereq: cross-ppc64-binutils >= 2.13.90.0.16-6
Obsoletes: cross-gcc3-ppc64

ExclusiveArch: ppc ppc64

Patch1: gcc32-sparc32-hack.patch
Patch2: gcc32-tls-reload-fix.patch
Patch3: gcc32-shared-pthread.patch
Patch4: gcc32-testsuite.patch
Patch5: gcc32-ada-make.patch
Patch6: gcc-3.2-spurious-reload.patch

%define _gnu %{nil}

%description
gcc 3.2 cross-development compiler for the ppc64 kernel

%prep
%setup -q -c %{name}-%{version}
cd ${RPM_BUILD_DIR}/%{name}-%{version}
mv -f ${RPM_BUILD_DIR}/%{name}-%{version} ${RPM_BUILD_DIR}/%{name}-%{version}.tmp
mv -f ${RPM_BUILD_DIR}/%{name}-%{version}.tmp/gcc-%{version}-%{DATE} ${RPM_BUILD_DIR}/%{name}-%{version}
rm -rf ${RPM_BUILD_DIR}/%{name}-%{version}.tmp
cd ${RPM_BUILD_DIR}/%{name}-%{version}

%patch -p1 -b .ppc64

%ifarch sparc
%patch1 -p0 -b .sparc32-hack~
%endif
%patch2 -p0 -b .tls-reload-fix~
%patch3 -p0 -b .shared-pthread~
%patch4 -p0 -b .testsuite~
%patch5 -p0 -b .ada-make~
%patch6 -p1 -b .spurious

perl -pi -e 's/3\.2\.2/3.2.1/' gcc/version.c gcc/f/version.c gcc/ada/gnatvsn.ads
perl -pi -e 's/"%{gcc_version}"/"%{gcc_version} \(release\)"/' gcc/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(Red Hat Linux 8.0 %{version}-%{gcc_release}\)/' gcc/version.c gcc/f/version.c
perl -pi -e 's/\((prerelease|experimental|release|Red Hat[^)]*)\)/\(%{version}-%{gcc_release}\)/' gcc/ada/gnatvsn.ads
perl -pi -e 's/#define GCCBUGURL.*$/#define GCCBUGURL "<URL:http:\/\/bugzilla.redhat.com\/bugzilla\/>"/' gcc/system.h
# The version string is now longer than 32 bytes and the line containing it
# doesn't fit into 80 columns
#perl -pi -e 's/:= 32/:= 64/;s/(Gnat_Version_String.*:=)/\1\n    /' gcc/ada/gnatvsn.ads

./contrib/gcc_update --touch

%define _prefix /opt/ppc64
%define _target_platform powerpc64-linux
%build
%configure \
	--enable-languages=c \
	--disable-nls \
	--disable-shared \
	--disable-threads \
	--enable-__cxa_atexit

if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi

make -j$RPM_BUILD_NCPUS

%install
rm -rf $RPM_BUILD_ROOT
%makeinstall
rm -rf $RPM_BUILD_ROOT%{_prefix}/share $RPM_BUILD_ROOT/usr/share
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libiberty.a
file $RPM_BUILD_ROOT/%{_prefix}/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_prefix}

%changelog
* Fri Mar 28 2003 Guy Streeter <streeter@redhat.com>
- fix for "`asm' operand requires spurious reload"

* Wed Jan 29 2003 Guy Streeter <streeter@redhat.com>
- 3.2.1

* Wed Oct 23 2002 Guy Streeter <streeter@redhat.com>
- change to use /opt/ppc64 instead of /usr/local

* Thu Oct 10 2002 Guy Streeter <streeter@redhat.com>
- update to RH 8.0 version

* Fri Apr 19 2002 Guy Streeter <streeter@redhat.com>
- Initial build.
